unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Purger, Shellapi;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button3: TButton;
    Edit2: TEdit;
    Label2: TLabel;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button2: TButton;
    Panel3: TPanel;
    Label7: TLabel;
    Button4: TButton;
    Label8: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Button5: TButton;
    Panel4: TPanel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Panel5: TPanel;
    Label13: TLabel;
    RadioGroup1: TRadioGroup;
    Panel6: TPanel;
    Label14: TLabel;
    Button6: TButton;
    Edit5: TEdit;
    Button7: TButton;
    Button8: TButton;
    OpenDialog1: TOpenDialog;
    Label15: TLabel;
    Panel7: TPanel;
    Label16: TLabel;
    Label17: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Label5DblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Label12MouseEnter(Sender: TObject);
    procedure Label12MouseLeave(Sender: TObject);
    procedure Label11DblClick(Sender: TObject);
    procedure Label12DblClick(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Panel7DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    MyStream : TStringStream;
    h : THandle;
    Time : TDateTime;
    Procedure OnPurgeComplete(Sender : TObject);
    Procedure OnPurgeBegin(Sender : TObject);
    Procedure WriteMem;
    Procedure SetMem;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
Var
  I : Integer;
begin
  MyStream.Size := 0;
  MyStream.Position := 0;
  For I := 1 to Length(Edit1.Text) Do
  Begin
    MyStream.WriteBuffer(Edit1.Text[I],1);
  End;
  Edit2.Text := MyStream.DataString;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MyStream := TStringStream.Create('Kewl');
  h := GlobalAlloc(GMEM_FIXED,128);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  MyStream.Free;    
  GlobalFree(h);
end;

procedure TForm1.Button3Click(Sender: TObject);
Var
  Sp : TStreamPurger;
begin
  Sp := TStreamPurger.Create;         //Creates the purger...
  Sp.OnPurgeEnd := OnPurgeComplete;   //Sets the handler to the handler in this form
  Sp.OnPurgeStart := OnPurgeBegin;    //(Same as Above...)
  Sp.Purge(MyStream);                 //Purges the stream
  Sp.Free;                            //Frees the purger
  Edit2.Text := MyStream.DataString;
end;

procedure TForm1.OnPurgeComplete(Sender: TObject);
{This handler is used by every purger upon finishing to purge}
begin
  MessageDlg('Purging using a '+Sender.ClassName +' Completed',mtInformation,[mbOk],0);
end;

procedure TForm1.Label5DblClick(Sender: TObject);
begin
  ShellExecute(0,PChar('Open'),PChar('wordpad'),nil,nil,SW_MAXIMIZE);
end;

procedure TForm1.Button2Click(Sender: TObject);
Var
  Clip : TClipboardPurger;
begin
  Clip := TClipboardPurger.Create;    //Creates the purger...
  Clip.OnPurgeEnd := OnPurgeComplete; //Sets the event to the handler in this form
  Clip.OnPurgeStart := OnPurgeBegin;  //(Same as Above...)
  Clip.PurgeTheClipboard;             //Purge the main windows clipboard
  Clip.Free;                          //Frees the purger
end;

procedure TForm1.Button4Click(Sender: TObject);
Var
  GP : TGlobalPurger;
begin
  GP := TGlobalPurger.Create;       //Creates the TGlobalPurger
  GP.OnPurgeEnd := OnPurgeComplete; //Sets the event to the handler in this form
  GP.OnPurgeStart := OnPurgeBegin;  //(Same as Above...)
  GP.Purge(GlobalLock(h));          //Purge...
  GlobalUnlock(h);                  //Frees h for access
  GP.Free;                          //Frees the purger
  WriteMem;
end;

procedure TForm1.WriteMem;
{This simply writes the content of the memory to the edit box}
Var
  D : DWORD;
  S : String;
  P : Pointer;
begin
  Edit3.Text := '';       //Zeros Edit3's text
  D := GlobalSize(h);     //Sets D to the size of the memory object handeled by h
  SetLength(S,D);         //Sets the string S to the size of the memory object (D)
  P := GlobalLock(h);     //Sets P to the point to the memory object handeled by h
  CopyMemory(@S[1],P,D);  //Copys D bytes from P to the string S
  GlobalUnlock(h);        //Makes h free again for access
  Edit3.Text := S;
end;

procedure TForm1.SetMem;
{This sets the memory to the content of the edit box}
Var
  D : DWORD;
  P : Pointer;
begin
  D := Length(Edit4.Text);         //D is the length of text in the Edit4 box
  P := GlobalLock(h);              //sets P as a pointer the the memory object handeled by h
  ZeroMemory(P,128);               //fill the memory with binary zeros
  CopyMemory(P,@Edit4.Text[1],D);  //copy D bytes from Edit4's text to the location pointed by p
  GlobalUnlock(h);                 //makes h free for access again
  WriteMem;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  SetMem;
end;

procedure TForm1.OnPurgeBegin(Sender: TObject);
begin
  If RadioGroup1.ItemIndex = 1 Then
    (Sender As TPurger).PurgingMethod := pmSchneier;
end;

procedure TForm1.Label12MouseEnter(Sender: TObject);
begin
  (Sender As TLabel).Font.Color := clHighlight;
end;

procedure TForm1.Label12MouseLeave(Sender: TObject);
begin
  (Sender As TLabel).Font.Color := clWindowText;
end;

procedure TForm1.Label11DblClick(Sender: TObject);
begin
  ShellExecute(0,PChar('Open'),PChar('thedeadh@netvision.net.il'),nil,nil,SW_MAXIMIZE);
end;

procedure TForm1.Label12DblClick(Sender: TObject);
begin
  ShellExecute(0,PChar('Open'),PChar('http://security.guides.co.il/'),nil,nil,SW_MAXIMIZE);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  If OpenDialog1.Execute Then
    Edit5.Text := OpenDialog1.FileName;
end;

procedure TForm1.Button7Click(Sender: TObject);
Var
  F : TFilePurger;
begin
  If Not FileExists(Edit5.Text) Then  //if file doesn't exists...
  Begin
    MessageDlg('File '+Edit5.Text+' Does Not Exist',mtError,[mbCancel],0);
    Exit;
  End;
  If MessageDlg('The File '+Edit5.Text+' Will Be Purged, And all it''s data will be overwriten, Continue?'
                ,mtWarning,mbOKCancel,0) = mrOk Then
  Begin
    Try
      F := TFilePurger.Create;          //Create the purger object
      F.OnPurgeEnd := OnPurgeComplete;  //Set the event to the handler defined in this form
      F.OnPurgeStart := OnPurgeBegin;   //(same as above...)
      F.Purge(Edit5.Text);              //Purge...
    Finally
      F.Free;                           //Finally free the purger object
    End;
  End;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  ShellExecute(0,PChar('Open'),PChar('notepad'),PChar(Edit5.Text),nil,SW_MAXIMIZE);
end;

procedure TForm1.Panel7DblClick(Sender: TObject);
begin
  MessageDlg('The empty TPanel of nothingness could not be evoked. Sorry.',mtError,[mbAbort],0);
end;

end.
